#!/bin/csh
setenv combo $argv[1]
echo "P1: $combo"
phenix.python<<EOD 
# count number of unique first entries in file
import sys
found_list=[]
first=True
file='raw_4_res.list'
print "FILE ",file
for line in open(file).readlines():
  if line:
    if first:  # skip 1st line
      first=False
      continue
    value=line.split()[0]
    if not value in found_list:
      found_list.append(value)
print "Unique entries: ",len(found_list)
f=open("datasets.list","w")
for entry in found_list:
  print >>f ,entry,
f.close()
EOD
foreach score (CC_DENMOD RFACTOR SKEW NCS_OVERLAP NCS_COPIES NCS_IN_GROUP TRUNCATE REGIONS CONTRAST FOM FLATNESS CORR_RMS)
echo "" > bayes_all_jackknife_combo_$score.log
foreach d ( `cat datasets.list` )
echo "dataset: $d"
head -1 raw_4_res.list > in.dat
cat raw_4_res.list|grep $d >> in.dat
cat raw_4_res.list|grep -v $d > out.dat
phenix.python bayes_5.py out.dat in.dat  $combo $score  >> bayes_all_jackknife_combo_$score.log
end
cat bayes_all_jackknife_combo_$score.log |grep EST >  ${score}_combo_EST.list

end
